// This file is automatically generated from dce_rpc.pac.

#include "dce_rpc_pac.h"

namespace BinPAC {

uuid::uuid()
	{
	make_array(val_, 0);
	}

uuid::~uuid()
	{
	delete_array(val_);
	}

int uuid::parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "uuid:val"
	if ( t_begin_of_data + (16) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("uuid:val",
			(0) + (16), 
			(t_end_of_data) - (t_begin_of_data));
		}
	int t_val__arraylength = 16;
	make_array<uint8>(val_, t_val__arraylength);
	const uint8* t_val__elem__data = t_begin_of_data;
	for ( int t_val__elem__it = 0; 
		t_val__elem__it < t_val__arraylength; 
		++t_val__elem__it )
		{
		uint8 t_val__elem;
		t_val__elem = *((uint8 *) (t_val__elem__data));
		val_.v[t_val__elem__it] = t_val__elem;
		t_val__elem__data += 1;
		}
	return 16;
	}

context_handle::context_handle()
	{
	cxt_attributes_ = 0;
	cxt_uuid_ = 0;
	}

context_handle::~context_handle()
	{
	delete cxt_uuid_;
	}

int context_handle::parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "context_handle:val"
	if ( t_begin_of_data + (20) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("context_handle:val",
			(0) + (20), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "cxt_attributes"
	cxt_attributes_ = UnMarshall<uint32>(t_begin_of_data, cxt_attributes_, t_byteorder);
	
	// Parse "cxt_uuid"
	cxt_uuid_ = new uuid();
	cxt_uuid_->parse((t_begin_of_data + 4), t_end_of_data, bigendian);
	
	return 20;
	}

rpc_if_id_t::rpc_if_id_t()
	{
	if_uuid_ = 0;
	vers_major_ = 0;
	vers_minor_ = 0;
	}

rpc_if_id_t::~rpc_if_id_t()
	{
	delete if_uuid_;
	}

int rpc_if_id_t::parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "rpc_if_id_t:val"
	if ( t_begin_of_data + (20) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("rpc_if_id_t:val",
			(0) + (20), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "if_uuid"
	if_uuid_ = new uuid();
	if_uuid_->parse(t_begin_of_data, t_end_of_data, bigendian);
	
	// Parse "vers_major"
	vers_major_ = UnMarshall<uint16>((t_begin_of_data + 16), vers_major_, t_byteorder);
	
	// Parse "vers_minor"
	vers_minor_ = UnMarshall<uint16>((t_begin_of_data + 18), vers_minor_, t_byteorder);
	
	return 20;
	}

NDR_Format::NDR_Format()
	{
	intchar_ = 0;
	floatspec_ = 0;
	byteorder_ = 0;
	}

NDR_Format::~NDR_Format()
	{
	}

int NDR_Format::parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "NDR_Format:val"
	if ( t_begin_of_data + (4) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("NDR_Format:val",
			(0) + (4), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "intchar"
	intchar_ = *((uint8 *) (t_begin_of_data));
	
	// Parse "floatspec"
	floatspec_ = *((uint8 *) ((t_begin_of_data + 1)));
	
	
	byteorder_ =  ( intchar() >> 4 )  ? littleendian : bigendian;
	
	return 4;
	}

DCE_RPC_Header::DCE_RPC_Header()
	{
	rpc_vers_ = 0;
	rpc_vers_minor_ = 0;
	PTYPE_ = 0;
	pfc_flags_ = 0;
	packed_drep_ = 0;
	frag_length_ = 0;
	auth_length_ = 0;
	call_id_ = 0;
	}

DCE_RPC_Header::~DCE_RPC_Header()
	{
	delete packed_drep_;
	}

int DCE_RPC_Header::parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "DCE_RPC_Header:val"
	if ( t_begin_of_data + (16) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("DCE_RPC_Header:val",
			(0) + (16), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "rpc_vers"
	rpc_vers_ = *((uint8 *) (t_begin_of_data));
	
	// Parse "rpc_vers_minor"
	rpc_vers_minor_ = *((uint8 *) ((t_begin_of_data + 1)));
	
	// Parse "PTYPE"
	PTYPE_ = *((uint8 *) ((t_begin_of_data + 2)));
	
	// Parse "pfc_flags"
	pfc_flags_ = *((uint8 *) ((t_begin_of_data + 3)));
	
	// Parse "packed_drep"
	packed_drep_ = new NDR_Format();
	packed_drep_->parse((t_begin_of_data + 4), t_end_of_data, bigendian);
	
	// Parse "frag_length"
	byteorder_ = packed_drep()->byteorder();
	frag_length_ = UnMarshall<uint16>((t_begin_of_data + 8), frag_length_, byteorder());
	
	// Parse "auth_length"
	auth_length_ = UnMarshall<uint16>((t_begin_of_data + 10), auth_length_, byteorder());
	
	// Parse "call_id"
	call_id_ = UnMarshall<uint32>((t_begin_of_data + 12), call_id_, byteorder());
	
	return 16;
	}

p_context_id_t::p_context_id_t()
	{
	val_ = 0;
	}

p_context_id_t::~p_context_id_t()
	{
	}

int p_context_id_t::parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "p_context_id_t:val"
	if ( t_begin_of_data + (2) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("p_context_id_t:val",
			(0) + (2), 
			(t_end_of_data) - (t_begin_of_data));
		}
	val_ = UnMarshall<uint16>(t_begin_of_data, val_, t_byteorder);
	return 2;
	}

p_syntax_id_t::p_syntax_id_t()
	{
	if_uuid_ = 0;
	if_version_ = 0;
	}

p_syntax_id_t::~p_syntax_id_t()
	{
	delete if_uuid_;
	}

int p_syntax_id_t::parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "p_syntax_id_t:val"
	if ( t_begin_of_data + (20) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("p_syntax_id_t:val",
			(0) + (20), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "if_uuid"
	if_uuid_ = new uuid();
	if_uuid_->parse(t_begin_of_data, t_end_of_data, bigendian);
	
	// Parse "if_version"
	if_version_ = UnMarshall<uint32>((t_begin_of_data + 16), if_version_, t_byteorder);
	
	return 20;
	}

p_cont_elem_t::p_cont_elem_t()
	{
	p_cont_id_ = 0;
	n_transfer_syn_ = 0;
	abstract_syntax_ = 0;
	make_array(transfer_syntaxes_, 0);
	}

p_cont_elem_t::~p_cont_elem_t()
	{
	delete p_cont_id_;
	delete abstract_syntax_;
	for ( int i = 0; i < transfer_syntaxes().size(); ++i )
		{
		p_syntax_id_t * t_transfer_syntaxes__elem = transfer_syntaxes_[i];
		delete t_transfer_syntaxes__elem;
		}
	delete_array(transfer_syntaxes_);
	}

int p_cont_elem_t::parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "p_cont_elem_t:abstract_syntax"
	if ( (t_begin_of_data + 4) + (20) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("p_cont_elem_t:abstract_syntax",
			(4) + (20), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "p_cont_id"
	p_cont_id_ = new p_context_id_t();
	p_cont_id_->parse(t_begin_of_data, t_end_of_data, t_byteorder);
	
	// Parse "n_transfer_syn"
	n_transfer_syn_ = *((uint8 *) ((t_begin_of_data + 2)));
	
	
	// Parse "abstract_syntax"
	abstract_syntax_ = new p_syntax_id_t();
	abstract_syntax_->parse((t_begin_of_data + 4), t_end_of_data, t_byteorder);
	
	// Parse "transfer_syntaxes"
	int t_transfer_syntaxes__arraylength = n_transfer_syn();
	int t_transfer_syntaxes__size = 20 * t_transfer_syntaxes__arraylength;
	// Checking out-of-bound for "p_cont_elem_t:transfer_syntaxes"
	if ( (t_begin_of_data + 24) + (t_transfer_syntaxes__size) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("p_cont_elem_t:transfer_syntaxes",
			(24) + (t_transfer_syntaxes__size), 
			(t_end_of_data) - (t_begin_of_data));
		}
	make_array<p_syntax_id_t *>(transfer_syntaxes_, t_transfer_syntaxes__arraylength);
	const uint8* t_transfer_syntaxes__elem__data = (t_begin_of_data + 24);
	for ( int t_transfer_syntaxes__elem__it = 0; 
		t_transfer_syntaxes__elem__it < t_transfer_syntaxes__arraylength; 
		++t_transfer_syntaxes__elem__it )
		{
		p_syntax_id_t * t_transfer_syntaxes__elem;
		t_transfer_syntaxes__elem = new p_syntax_id_t();
		t_transfer_syntaxes__elem->parse(t_transfer_syntaxes__elem__data, t_end_of_data, t_byteorder);
		transfer_syntaxes_.v[t_transfer_syntaxes__elem__it] = t_transfer_syntaxes__elem;
		t_transfer_syntaxes__elem__data += 20;
		}
	
	const uint8* const t_dataptr_after_transfer_syntaxes = (t_begin_of_data + 24) + (t_transfer_syntaxes__size);
	int t_val__size = t_dataptr_after_transfer_syntaxes - t_begin_of_data;
	return t_val__size;
	}

p_cont_list_t::p_cont_list_t()
	{
	n_context_elem_ = 0;
	make_array(p_cont_elem_, 0);
	}

p_cont_list_t::~p_cont_list_t()
	{
	for ( int i = 0; i < p_cont_elem().size(); ++i )
		{
		p_cont_elem_t * t_p_cont_elem__elem = p_cont_elem_[i];
		delete t_p_cont_elem__elem;
		}
	delete_array(p_cont_elem_);
	}

int p_cont_list_t::parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "p_cont_list_t:reserved"
	if ( (t_begin_of_data + 1) + (3) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("p_cont_list_t:reserved",
			(1) + (3), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "n_context_elem"
	n_context_elem_ = *((uint8 *) (t_begin_of_data));
	
	
	// Parse "p_cont_elem"
	int t_p_cont_elem__arraylength = n_context_elem();
	make_array<p_cont_elem_t *>(p_cont_elem_, t_p_cont_elem__arraylength);
	const uint8* t_p_cont_elem__elem__data = (t_begin_of_data + 4);
	for ( int t_p_cont_elem__elem__it = 0; 
		t_p_cont_elem__elem__it < t_p_cont_elem__arraylength; 
		++t_p_cont_elem__elem__it )
		{
		p_cont_elem_t * t_p_cont_elem__elem;
		t_p_cont_elem__elem = new p_cont_elem_t();
		int t_p_cont_elem__elem__size = 
			t_p_cont_elem__elem->parse(t_p_cont_elem__elem__data, t_end_of_data, t_byteorder);
		p_cont_elem_.v[t_p_cont_elem__elem__it] = t_p_cont_elem__elem;
		t_p_cont_elem__elem__data += t_p_cont_elem__elem__size;
		}
	int t_p_cont_elem__size = t_p_cont_elem__elem__data - (t_begin_of_data + 4);
	
	const uint8* const t_dataptr_after_p_cont_elem = (t_begin_of_data + 4) + (t_p_cont_elem__size);
	int t_val__size = t_dataptr_after_p_cont_elem - t_begin_of_data;
	return t_val__size;
	}

DCE_RPC_Bind::DCE_RPC_Bind()
	{
	max_xmit_frag_ = 0;
	max_recv_frag_ = 0;
	assoc_group_id_ = 0;
	p_context_elem_ = 0;
	}

DCE_RPC_Bind::~DCE_RPC_Bind()
	{
	delete p_context_elem_;
	}

int DCE_RPC_Bind::parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "DCE_RPC_Bind:assoc_group_id"
	if ( (t_begin_of_data + 4) + (4) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("DCE_RPC_Bind:assoc_group_id",
			(4) + (4), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "max_xmit_frag"
	max_xmit_frag_ = UnMarshall<uint16>(t_begin_of_data, max_xmit_frag_, t_byteorder);
	
	// Parse "max_recv_frag"
	max_recv_frag_ = UnMarshall<uint16>((t_begin_of_data + 2), max_recv_frag_, t_byteorder);
	
	// Parse "assoc_group_id"
	assoc_group_id_ = UnMarshall<uint32>((t_begin_of_data + 4), assoc_group_id_, t_byteorder);
	
	// Parse "p_context_elem"
	p_context_elem_ = new p_cont_list_t();
	int t_p_context_elem__size = 
		p_context_elem_->parse((t_begin_of_data + 8), t_end_of_data, t_byteorder);
	
	const uint8* const t_dataptr_after_p_context_elem = (t_begin_of_data + 8) + (t_p_context_elem__size);
	int t_val__size = t_dataptr_after_p_context_elem - t_begin_of_data;
	return t_val__size;
	}

DCE_RPC_Request::DCE_RPC_Request(int arg_length)
	{
	length_ = arg_length;
	alloc_hint_ = 0;
	p_cont_id_ = 0;
	opnum_ = 0;
	make_array(stub_, 0);
	}

DCE_RPC_Request::~DCE_RPC_Request()
	{
	delete p_cont_id_;
	delete_array(stub_);
	}

int DCE_RPC_Request::parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "DCE_RPC_Request:opnum"
	if ( (t_begin_of_data + 6) + (2) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("DCE_RPC_Request:opnum",
			(6) + (2), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "alloc_hint"
	alloc_hint_ = UnMarshall<uint32>(t_begin_of_data, alloc_hint_, t_byteorder);
	
	// Parse "p_cont_id"
	p_cont_id_ = new p_context_id_t();
	p_cont_id_->parse((t_begin_of_data + 4), t_end_of_data, t_byteorder);
	
	// Parse "opnum"
	opnum_ = UnMarshall<uint16>((t_begin_of_data + 6), opnum_, t_byteorder);
	
	// Parse "stub"
	int t_stub__arraylength = length() - 8;
	int t_stub__size = 1 * t_stub__arraylength;
	// Checking out-of-bound for "DCE_RPC_Request:stub"
	if ( (t_begin_of_data + 8) + (t_stub__size) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("DCE_RPC_Request:stub",
			(8) + (t_stub__size), 
			(t_end_of_data) - (t_begin_of_data));
		}
	make_array<uint8>(stub_, t_stub__arraylength);
	const uint8* t_stub__elem__data = (t_begin_of_data + 8);
	for ( int t_stub__elem__it = 0; 
		t_stub__elem__it < t_stub__arraylength; 
		++t_stub__elem__it )
		{
		uint8 t_stub__elem;
		t_stub__elem = *((uint8 *) (t_stub__elem__data));
		stub_.v[t_stub__elem__it] = t_stub__elem;
		t_stub__elem__data += 1;
		}
	
	const uint8* const t_dataptr_after_stub = (t_begin_of_data + 8) + (t_stub__size);
	int t_val__size = t_dataptr_after_stub - t_begin_of_data;
	return t_val__size;
	}

DCE_RPC_Response::DCE_RPC_Response(int arg_length)
	{
	length_ = arg_length;
	alloc_hint_ = 0;
	p_cont_id_ = 0;
	cancel_count_ = 0;
	reserved_ = 0;
	make_array(stub_, 0);
	}

DCE_RPC_Response::~DCE_RPC_Response()
	{
	delete p_cont_id_;
	delete_array(stub_);
	}

int DCE_RPC_Response::parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "DCE_RPC_Response:reserved"
	if ( (t_begin_of_data + 7) + (1) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("DCE_RPC_Response:reserved",
			(7) + (1), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "alloc_hint"
	alloc_hint_ = UnMarshall<uint32>(t_begin_of_data, alloc_hint_, t_byteorder);
	
	// Parse "p_cont_id"
	p_cont_id_ = new p_context_id_t();
	p_cont_id_->parse((t_begin_of_data + 4), t_end_of_data, t_byteorder);
	
	// Parse "cancel_count"
	cancel_count_ = *((uint8 *) ((t_begin_of_data + 6)));
	
	// Parse "reserved"
	reserved_ = *((uint8 *) ((t_begin_of_data + 7)));
	
	// Parse "stub"
	int t_stub__arraylength = length() - 8;
	int t_stub__size = 1 * t_stub__arraylength;
	// Checking out-of-bound for "DCE_RPC_Response:stub"
	if ( (t_begin_of_data + 8) + (t_stub__size) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("DCE_RPC_Response:stub",
			(8) + (t_stub__size), 
			(t_end_of_data) - (t_begin_of_data));
		}
	make_array<uint8>(stub_, t_stub__arraylength);
	const uint8* t_stub__elem__data = (t_begin_of_data + 8);
	for ( int t_stub__elem__it = 0; 
		t_stub__elem__it < t_stub__arraylength; 
		++t_stub__elem__it )
		{
		uint8 t_stub__elem;
		t_stub__elem = *((uint8 *) (t_stub__elem__data));
		stub_.v[t_stub__elem__it] = t_stub__elem;
		t_stub__elem__data += 1;
		}
	
	const uint8* const t_dataptr_after_stub = (t_begin_of_data + 8) + (t_stub__size);
	int t_val__size = t_dataptr_after_stub - t_begin_of_data;
	return t_val__size;
	}

DCE_RPC_Body::DCE_RPC_Body(DCE_RPC_Header* arg_header, int arg_length)
	{
	header_ = arg_header;
	length_ = arg_length;
	val_case_index_ = -1;
	}

DCE_RPC_Body::~DCE_RPC_Body()
	{
	switch ( val_case_index() )
		{
		case 11:
			// Clean up "bind"
			{
			delete val_.bind_;
			}
			break;
		case 0:
			// Clean up "request"
			{
			delete val_.request_;
			}
			break;
		case 2:
			// Clean up "response"
			{
			delete val_.response_;
			}
			break;
		default:
			// Clean up "other"
			{
			delete_array(val_.other_);
			}
			break;
		}
	}

int DCE_RPC_Body::parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder)
	{
	int t_val__size;
	val_case_index_ = header()->PTYPE();
	switch ( val_case_index() )
		{
		case 11:
			// Parse "bind"
			{
			val_.bind_ = new DCE_RPC_Bind();
			int t_bind__size = 
				val_.bind_->parse(t_begin_of_data, t_end_of_data, t_byteorder);
			t_val__size = t_bind__size;
			}
			break;
		case 0:
			// Parse "request"
			{
			val_.request_ = new DCE_RPC_Request(length());
			int t_request__size = 
				val_.request_->parse(t_begin_of_data, t_end_of_data, t_byteorder);
			t_val__size = t_request__size;
			}
			break;
		case 2:
			// Parse "response"
			{
			val_.response_ = new DCE_RPC_Response(length());
			int t_response__size = 
				val_.response_->parse(t_begin_of_data, t_end_of_data, t_byteorder);
			t_val__size = t_response__size;
			}
			break;
		default:
			// Parse "other"
			{
			int t_other__arraylength = length();
			int t_other__size = 1 * t_other__arraylength;
			// Checking out-of-bound for "DCE_RPC_Body:other"
			if ( t_begin_of_data + (t_other__size) > t_end_of_data )
				{
				// Handle out-of-bound condition
				throw ExceptionOutOfBound("DCE_RPC_Body:other",
					(0) + (t_other__size), 
					(t_end_of_data) - (t_begin_of_data));
				}
			make_array<uint8>(val_.other_, t_other__arraylength);
			const uint8* t_other__elem__data = t_begin_of_data;
			for ( int t_other__elem__it = 0; 
				t_other__elem__it < t_other__arraylength; 
				++t_other__elem__it )
				{
				uint8 t_other__elem;
				t_other__elem = *((uint8 *) (t_other__elem__data));
				val_.other_.v[t_other__elem__it] = t_other__elem;
				t_other__elem__data += 1;
				}
			t_val__size = t_other__size;
			}
			break;
		}
	return t_val__size;
	}

DCE_RPC_Auth::DCE_RPC_Auth(DCE_RPC_Header* arg_header)
	{
	header_ = arg_header;
	val_case_index_ = -1;
	}

DCE_RPC_Auth::~DCE_RPC_Auth()
	{
	switch ( val_case_index() )
		{
		case 0:
			// Clean up "none"
			{
			}
			break;
		default:
			// Clean up "auth_verifier"
			{
			delete_array(val_.auth_verifier_);
			}
			break;
		}
	}

int DCE_RPC_Auth::parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder)
	{
	int t_val__size;
	val_case_index_ = header()->auth_length();
	switch ( val_case_index() )
		{
		case 0:
			// Parse "none"
			{
			// Checking out-of-bound for "DCE_RPC_Auth:none"
			if ( t_begin_of_data + (0) > t_end_of_data )
				{
				// Handle out-of-bound condition
				throw ExceptionOutOfBound("DCE_RPC_Auth:none",
					(0) + (0), 
					(t_end_of_data) - (t_begin_of_data));
				}
			t_val__size = 0;
			}
			break;
		default:
			// Parse "auth_verifier"
			{
			int t_auth_verifier__arraylength = header()->auth_length();
			int t_auth_verifier__size = 1 * t_auth_verifier__arraylength;
			// Checking out-of-bound for "DCE_RPC_Auth:auth_verifier"
			if ( t_begin_of_data + (t_auth_verifier__size) > t_end_of_data )
				{
				// Handle out-of-bound condition
				throw ExceptionOutOfBound("DCE_RPC_Auth:auth_verifier",
					(0) + (t_auth_verifier__size), 
					(t_end_of_data) - (t_begin_of_data));
				}
			make_array<uint8>(val_.auth_verifier_, t_auth_verifier__arraylength);
			const uint8* t_auth_verifier__elem__data = t_begin_of_data;
			for ( int t_auth_verifier__elem__it = 0; 
				t_auth_verifier__elem__it < t_auth_verifier__arraylength; 
				++t_auth_verifier__elem__it )
				{
				uint8 t_auth_verifier__elem;
				t_auth_verifier__elem = *((uint8 *) (t_auth_verifier__elem__data));
				val_.auth_verifier_.v[t_auth_verifier__elem__it] = t_auth_verifier__elem;
				t_auth_verifier__elem__data += 1;
				}
			t_val__size = t_auth_verifier__size;
			}
			break;
		}
	return t_val__size;
	}

DCE_RPC_PDU::DCE_RPC_PDU()
	{
	body_length_ = 0;
	header_ = 0;
	body_ = 0;
	auth_ = 0;
	}

DCE_RPC_PDU::~DCE_RPC_PDU()
	{
	delete header_;
	delete body_;
	delete auth_;
	}

int DCE_RPC_PDU::parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "DCE_RPC_PDU:header"
	if ( t_begin_of_data + (16) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("DCE_RPC_PDU:header",
			(0) + (16), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "header"
	header_ = new DCE_RPC_Header();
	t_byteorder = littleendian;
	header_->parse(t_begin_of_data, t_end_of_data, t_byteorder);
	body_length_ = header()->frag_length() - 16 - header()->auth_length();
	
	// Parse "header"
	
	// Parse "body"
	body_ = new DCE_RPC_Body(header(), body_length());
	byteorder_ = header()->byteorder();
	int t_body__size = 
		body_->parse((t_begin_of_data + 16), t_end_of_data, byteorder());
	
	const uint8* const t_dataptr_after_body = (t_begin_of_data + 16) + (t_body__size);
	// Parse "auth"
	auth_ = new DCE_RPC_Auth(header());
	int t_auth__size = 
		auth_->parse(t_dataptr_after_body, t_end_of_data, bigendian);
	
	const uint8* const t_dataptr_after_auth = t_dataptr_after_body + (t_auth__size);
	int t_val__size = t_dataptr_after_auth - t_begin_of_data;
	return t_val__size;
	}

epmapper_lookup_req::epmapper_lookup_req()
	{
	inquiry_type_ = 0;
	object_ = 0;
	interface_id_ = 0;
	vers_option_ = 0;
	entry_handle_ = 0;
	}

epmapper_lookup_req::~epmapper_lookup_req()
	{
	delete entry_handle_;
	}

int epmapper_lookup_req::parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "epmapper_lookup_req:val"
	if ( t_begin_of_data + (36) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("epmapper_lookup_req:val",
			(0) + (36), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "inquiry_type"
	inquiry_type_ = UnMarshall<uint32>(t_begin_of_data, inquiry_type_, t_byteorder);
	
	// Parse "object"
	object_ = UnMarshall<uint32>((t_begin_of_data + 4), object_, t_byteorder);
	
	// Parse "interface_id"
	interface_id_ = UnMarshall<uint32>((t_begin_of_data + 8), interface_id_, t_byteorder);
	
	// Parse "vers_option"
	vers_option_ = UnMarshall<uint32>((t_begin_of_data + 12), vers_option_, t_byteorder);
	
	// Parse "entry_handle"
	entry_handle_ = new context_handle();
	entry_handle_->parse((t_begin_of_data + 16), t_end_of_data, t_byteorder);
	
	return 36;
	}

epmapper_map_req::epmapper_map_req()
	{
	}

epmapper_map_req::~epmapper_map_req()
	{
	}

int epmapper_map_req::parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "epmapper_map_req:val"
	if ( t_begin_of_data + (0) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("epmapper_map_req:val",
			(0) + (0), 
			(t_end_of_data) - (t_begin_of_data));
		}
	return 0;
	}

epm_uuid::epm_uuid()
	{
	if_uuid_ = 0;
	if_version_ = 0;
	}

epm_uuid::~epm_uuid()
	{
	delete if_uuid_;
	}

int epm_uuid::parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "epm_uuid:val"
	if ( t_begin_of_data + (18) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("epm_uuid:val",
			(0) + (18), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "if_uuid"
	if_uuid_ = new uuid();
	if_uuid_->parse(t_begin_of_data, t_end_of_data, bigendian);
	
	// Parse "if_version"
	byteorder_ = littleendian;
	if_version_ = UnMarshall<uint16>((t_begin_of_data + 16), if_version_, byteorder());
	
	return 18;
	}

epm_port::epm_port()
	{
	val_ = 0;
	}

epm_port::~epm_port()
	{
	}

int epm_port::parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "epm_port:val"
	if ( t_begin_of_data + (2) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("epm_port:val",
			(0) + (2), 
			(t_end_of_data) - (t_begin_of_data));
		}
	byteorder_ = bigendian;
	val_ = UnMarshall<uint16>(t_begin_of_data, val_, byteorder());
	return 2;
	}

epm_ip::epm_ip()
	{
	val_ = 0;
	}

epm_ip::~epm_ip()
	{
	}

int epm_ip::parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "epm_ip:val"
	if ( t_begin_of_data + (4) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("epm_ip:val",
			(0) + (4), 
			(t_end_of_data) - (t_begin_of_data));
		}
	byteorder_ = bigendian;
	val_ = UnMarshall<uint32>(t_begin_of_data, val_, byteorder());
	return 4;
	}

epm_lhs_data::epm_lhs_data(int arg_length, int arg_protocol)
	{
	length_ = arg_length;
	protocol_ = arg_protocol;
	val_case_index_ = -1;
	}

epm_lhs_data::~epm_lhs_data()
	{
	switch ( val_case_index() )
		{
		case 13:
			// Clean up "uuid"
			{
			delete val_.uuid_;
			}
			break;
		default:
			// Clean up "other"
			{
			delete_array(val_.other_);
			}
			break;
		}
	}

int epm_lhs_data::parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder)
	{
	int t_val__size;
	val_case_index_ = protocol();
	switch ( val_case_index() )
		{
		case 13:
			// Parse "uuid"
			{
			val_.uuid_ = new epm_uuid();
			val_.uuid_->parse(t_begin_of_data, t_end_of_data, t_byteorder);
			t_val__size = 18;
			}
			break;
		default:
			// Parse "other"
			{
			int t_other__arraylength = length();
			int t_other__size = 1 * t_other__arraylength;
			// Checking out-of-bound for "epm_lhs_data:other"
			if ( t_begin_of_data + (t_other__size) > t_end_of_data )
				{
				// Handle out-of-bound condition
				throw ExceptionOutOfBound("epm_lhs_data:other",
					(0) + (t_other__size), 
					(t_end_of_data) - (t_begin_of_data));
				}
			make_array<uint8>(val_.other_, t_other__arraylength);
			const uint8* t_other__elem__data = t_begin_of_data;
			for ( int t_other__elem__it = 0; 
				t_other__elem__it < t_other__arraylength; 
				++t_other__elem__it )
				{
				uint8 t_other__elem;
				t_other__elem = *((uint8 *) (t_other__elem__data));
				val_.other_.v[t_other__elem__it] = t_other__elem;
				t_other__elem__data += 1;
				}
			t_val__size = t_other__size;
			}
			break;
		}
	return t_val__size;
	}

epm_rhs_data::epm_rhs_data(int arg_length, int arg_protocol)
	{
	length_ = arg_length;
	protocol_ = arg_protocol;
	val_case_index_ = -1;
	}

epm_rhs_data::~epm_rhs_data()
	{
	switch ( val_case_index() )
		{
		case 7:
			// Clean up "tcp"
			{
			delete val_.tcp_;
			}
			break;
		case 8:
			// Clean up "udp"
			{
			delete val_.udp_;
			}
			break;
		case 9:
			// Clean up "ip"
			{
			delete val_.ip_;
			}
			break;
		default:
			// Clean up "other"
			{
			delete_array(val_.other_);
			}
			break;
		}
	}

int epm_rhs_data::parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder)
	{
	int t_val__size;
	val_case_index_ = protocol();
	switch ( val_case_index() )
		{
		case 7:
			// Parse "tcp"
			{
			val_.tcp_ = new epm_port();
			val_.tcp_->parse(t_begin_of_data, t_end_of_data, t_byteorder);
			t_val__size = 2;
			}
			break;
		case 8:
			// Parse "udp"
			{
			val_.udp_ = new epm_port();
			val_.udp_->parse(t_begin_of_data, t_end_of_data, t_byteorder);
			t_val__size = 2;
			}
			break;
		case 9:
			// Parse "ip"
			{
			val_.ip_ = new epm_ip();
			val_.ip_->parse(t_begin_of_data, t_end_of_data, t_byteorder);
			t_val__size = 4;
			}
			break;
		default:
			// Parse "other"
			{
			int t_other__arraylength = length();
			int t_other__size = 1 * t_other__arraylength;
			// Checking out-of-bound for "epm_rhs_data:other"
			if ( t_begin_of_data + (t_other__size) > t_end_of_data )
				{
				// Handle out-of-bound condition
				throw ExceptionOutOfBound("epm_rhs_data:other",
					(0) + (t_other__size), 
					(t_end_of_data) - (t_begin_of_data));
				}
			make_array<uint8>(val_.other_, t_other__arraylength);
			const uint8* t_other__elem__data = t_begin_of_data;
			for ( int t_other__elem__it = 0; 
				t_other__elem__it < t_other__arraylength; 
				++t_other__elem__it )
				{
				uint8 t_other__elem;
				t_other__elem = *((uint8 *) (t_other__elem__data));
				val_.other_.v[t_other__elem__it] = t_other__elem;
				t_other__elem__data += 1;
				}
			t_val__size = t_other__size;
			}
			break;
		}
	return t_val__size;
	}

epm_lhs::epm_lhs()
	{
	length_ = 0;
	protocol_ = 0;
	data_ = 0;
	}

epm_lhs::~epm_lhs()
	{
	delete data_;
	}

int epm_lhs::parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "epm_lhs:protocol"
	if ( (t_begin_of_data + 2) + (1) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("epm_lhs:protocol",
			(2) + (1), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "length"
	byteorder_ = littleendian;
	length_ = UnMarshall<uint16>(t_begin_of_data, length_, byteorder());
	
	// Parse "protocol"
	protocol_ = *((uint8 *) ((t_begin_of_data + 2)));
	
	// Parse "data"
	data_ = new epm_lhs_data(length() - 1, protocol());
	int t_data__size = 
		data_->parse((t_begin_of_data + 3), t_end_of_data, byteorder());
	
	const uint8* const t_dataptr_after_data = (t_begin_of_data + 3) + (t_data__size);
	int t_val__size = t_dataptr_after_data - t_begin_of_data;
	return t_val__size;
	}

epm_rhs::epm_rhs(int arg_protocol)
	{
	protocol_ = arg_protocol;
	length_ = 0;
	data_ = 0;
	}

epm_rhs::~epm_rhs()
	{
	delete data_;
	}

int epm_rhs::parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "epm_rhs:length"
	if ( t_begin_of_data + (2) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("epm_rhs:length",
			(0) + (2), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "length"
	byteorder_ = littleendian;
	length_ = UnMarshall<uint16>(t_begin_of_data, length_, byteorder());
	
	// Parse "data"
	data_ = new epm_rhs_data(length(), protocol());
	int t_data__size = 
		data_->parse((t_begin_of_data + 2), t_end_of_data, byteorder());
	
	const uint8* const t_dataptr_after_data = (t_begin_of_data + 2) + (t_data__size);
	int t_val__size = t_dataptr_after_data - t_begin_of_data;
	return t_val__size;
	}

epm_floor::epm_floor()
	{
	protocol_ = 0;
	lhs_ = 0;
	rhs_ = 0;
	}

epm_floor::~epm_floor()
	{
	delete lhs_;
	delete rhs_;
	}

int epm_floor::parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder)
	{
	// Parse "lhs"
	lhs_ = new epm_lhs();
	int t_lhs__size = 
		lhs_->parse(t_begin_of_data, t_end_of_data, t_byteorder);
	protocol_ = lhs()->protocol();
	
	// Parse "lhs"
	
	const uint8* const t_dataptr_after_lhs = t_begin_of_data + (t_lhs__size);
	// Parse "rhs"
	rhs_ = new epm_rhs(protocol());
	int t_rhs__size = 
		rhs_->parse(t_dataptr_after_lhs, t_end_of_data, t_byteorder);
	
	const uint8* const t_dataptr_after_rhs = t_dataptr_after_lhs + (t_rhs__size);
	int t_val__size = t_dataptr_after_rhs - t_begin_of_data;
	return t_val__size;
	}

epm_tower::epm_tower()
	{
	num_floors_ = 0;
	make_array(floors_, 0);
	}

epm_tower::~epm_tower()
	{
	for ( int i = 0; i < floors().size(); ++i )
		{
		epm_floor * t_floors__elem = floors_[i];
		delete t_floors__elem;
		}
	delete_array(floors_);
	}

int epm_tower::parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "epm_tower:num_floors"
	if ( t_begin_of_data + (2) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("epm_tower:num_floors",
			(0) + (2), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "num_floors"
	byteorder_ = littleendian;
	num_floors_ = UnMarshall<uint16>(t_begin_of_data, num_floors_, byteorder());
	
	// Parse "floors"
	int t_floors__arraylength = num_floors();
	make_array<epm_floor *>(floors_, t_floors__arraylength);
	const uint8* t_floors__elem__data = (t_begin_of_data + 2);
	for ( int t_floors__elem__it = 0; 
		t_floors__elem__it < t_floors__arraylength; 
		++t_floors__elem__it )
		{
		epm_floor * t_floors__elem;
		t_floors__elem = new epm_floor();
		int t_floors__elem__size = 
			t_floors__elem->parse(t_floors__elem__data, t_end_of_data, byteorder());
		floors_.v[t_floors__elem__it] = t_floors__elem;
		t_floors__elem__data += t_floors__elem__size;
		}
	int t_floors__size = t_floors__elem__data - (t_begin_of_data + 2);
	
	const uint8* const t_dataptr_after_floors = (t_begin_of_data + 2) + (t_floors__size);
	int t_val__size = t_dataptr_after_floors - t_begin_of_data;
	return t_val__size;
	}

epm_twr_p::epm_twr_p()
	{
	ref_ = 0;
	length_ = 0;
	tower_length_ = 0;
	tower_ = 0;
	}

epm_twr_p::~epm_twr_p()
	{
	delete tower_;
	}

int epm_twr_p::parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "epm_twr_p:tower_length"
	if ( (t_begin_of_data + 8) + (4) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("epm_twr_p:tower_length",
			(8) + (4), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "ref"
	ref_ = UnMarshall<uint32>(t_begin_of_data, ref_, t_byteorder);
	
	// Parse "length"
	length_ = UnMarshall<uint32>((t_begin_of_data + 4), length_, t_byteorder);
	
	// Parse "tower_length"
	tower_length_ = UnMarshall<uint32>((t_begin_of_data + 8), tower_length_, t_byteorder);
	
	// Parse "tower"
	tower_ = new epm_tower();
	int t_tower__size = 
		tower_->parse((t_begin_of_data + 12), t_end_of_data, t_byteorder);
	
	const uint8* const t_dataptr_after_tower = (t_begin_of_data + 12) + (t_tower__size);
	int t_val__size = t_dataptr_after_tower - t_begin_of_data;
	return t_val__size;
	}

epm_tower_array::epm_tower_array()
	{
	max_count_ = 0;
	offset_ = 0;
	actual_count_ = 0;
	make_array(towers_, 0);
	}

epm_tower_array::~epm_tower_array()
	{
	for ( int i = 0; i < towers().size(); ++i )
		{
		epm_twr_p * t_towers__elem = towers_[i];
		delete t_towers__elem;
		}
	delete_array(towers_);
	}

int epm_tower_array::parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "epm_tower_array:actual_count"
	if ( (t_begin_of_data + 8) + (4) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("epm_tower_array:actual_count",
			(8) + (4), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "max_count"
	max_count_ = UnMarshall<uint32>(t_begin_of_data, max_count_, t_byteorder);
	
	// Parse "offset"
	offset_ = UnMarshall<uint32>((t_begin_of_data + 4), offset_, t_byteorder);
	
	// Parse "actual_count"
	actual_count_ = UnMarshall<uint32>((t_begin_of_data + 8), actual_count_, t_byteorder);
	
	// Parse "towers"
	int t_towers__arraylength = actual_count();
	make_array<epm_twr_p *>(towers_, t_towers__arraylength);
	const uint8* t_towers__elem__data = (t_begin_of_data + 12);
	for ( int t_towers__elem__it = 0; 
		t_towers__elem__it < t_towers__arraylength; 
		++t_towers__elem__it )
		{
		epm_twr_p * t_towers__elem;
		t_towers__elem = new epm_twr_p();
		int t_towers__elem__size = 
			t_towers__elem->parse(t_towers__elem__data, t_end_of_data, t_byteorder);
		towers_.v[t_towers__elem__it] = t_towers__elem;
		t_towers__elem__data += t_towers__elem__size;
		}
	int t_towers__size = t_towers__elem__data - (t_begin_of_data + 12);
	
	const uint8* const t_dataptr_after_towers = (t_begin_of_data + 12) + (t_towers__size);
	int t_val__size = t_dataptr_after_towers - t_begin_of_data;
	return t_val__size;
	}

epmapper_map_resp::epmapper_map_resp()
	{
	entry_handle_ = 0;
	num_towers_ = 0;
	towers_ = 0;
	return_code_ = 0;
	}

epmapper_map_resp::~epmapper_map_resp()
	{
	delete entry_handle_;
	delete towers_;
	}

int epmapper_map_resp::parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "epmapper_map_resp:num_towers"
	if ( (t_begin_of_data + 20) + (4) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("epmapper_map_resp:num_towers",
			(20) + (4), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "entry_handle"
	entry_handle_ = new context_handle();
	entry_handle_->parse(t_begin_of_data, t_end_of_data, t_byteorder);
	
	// Parse "num_towers"
	num_towers_ = UnMarshall<uint32>((t_begin_of_data + 20), num_towers_, t_byteorder);
	
	// Parse "towers"
	towers_ = new epm_tower_array();
	int t_towers__size = 
		towers_->parse((t_begin_of_data + 24), t_end_of_data, t_byteorder);
	
	const uint8* const t_dataptr_after_towers = (t_begin_of_data + 24) + (t_towers__size);
	// Checking out-of-bound for "epmapper_map_resp:return_code"
	if ( t_dataptr_after_towers + (4) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("epmapper_map_resp:return_code",
			((t_dataptr_after_towers - t_begin_of_data)) + (4), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "return_code"
	return_code_ = UnMarshall<uint32>(t_dataptr_after_towers, return_code_, t_byteorder);
	
	int t_val__size = (t_dataptr_after_towers + 4) - t_begin_of_data;
	return t_val__size;
	}

} /* namespace BinPAC */
